/*****************************************************************************/
/*                                                                           */
/*  File Name   : IDMSAMP.H                                                  */
/*                                                                           */
/*  Copyright (C) 1995 IBM Corporation                                       */
/*                                                                           */
/*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is          */
/*      sample code created by IBM Corporation. This sample code is not      */
/*      part of any standard or IBM product and is provided to you solely    */
/*      for  the purpose of assisting you in the development of your         */
/*      applications.  The code is provided "AS IS", without                 */
/*      warranty of any kind.  IBM shall not be liable for any damages       */
/*      arising out of your use of the sample code, even if they have been   */
/*      advised of the possibility of such damages.                          */
/*                                                                           */
/*****************************************************************************/

#define WM_INITMYWINDOW       (WM_USER + 1)
#define ID_REPAINT            (WM_USER + 2)
#define ID_MAINWND               100
#define ID_SMILE                 200

/*
 *  Menu item ids
 */
#define IDM_FILE                 1000
#define IDM_OPEN                 2000
#define IDM_OPTIONS              3000
#define IDM_COLOR                4000
#define IDM_ANIMATION            5000
#define ID_QUIT                  6000

#define ID_ICONS                 2100
#define ID_ANIMATE               2101
#define ID_WRITE                 2102

#define ID_BOARD_COLORS          2300
#define ID_BOARD_WHITE           2301
#define ID_BOARD_BLACK           2302
#define ID_BOARD_RED             2303
#define ID_BOARD_BLUE            2304
#define ID_BOARD_PINK            2305
#define ID_BOARD_GREEN           2306
#define ID_BOARD_CYAN            2307
#define ID_BOARD_YELLOW          2308
#define ID_BOARD_BROWN           2309
#define ID_BOARD_PALEGRAY        2300
#define ID_BOARD_DARKGRAY        2311
#define ID_BOARD_DARKRED         2312
#define ID_BOARD_DARKBLUE        2313
#define ID_BOARD_DARKPINK        2314
#define ID_BOARD_DARKGREEN       2315
#define ID_BOARD_DARKCYAN        2316

#define ID_ANIMATE_COLORS        2400
#define ID_ANIMATE_WHITE         2401
#define ID_ANIMATE_BLACK         2402
#define ID_ANIMATE_RED           2403
#define ID_ANIMATE_BLUE          2404
#define ID_ANIMATE_PINK          2405
#define ID_ANIMATE_GREEN         2406
#define ID_ANIMATE_CYAN          2407
#define ID_ANIMATE_YELLOW        2408
#define ID_ANIMATE_BROWN         2409
#define ID_ANIMATE_PALEGRAY      2400
#define ID_ANIMATE_DARKGRAY      2411
#define ID_ANIMATE_DARKRED       2412
#define ID_ANIMATE_DARKBLUE      2413
#define ID_ANIMATE_DARKPINK      2414
#define ID_ANIMATE_DARKGREEN     2415
#define ID_ANIMATE_DARKCYAN      2416

#define ID_ANIM_SPEED            2450
#define ID_ANIM_SPEED1           2451
#define ID_ANIM_SPEED2           2452

#define ID_DRAW_COLORS           2500
#define ID_DRAW_WHITE            2501
#define ID_DRAW_BLACK            2502
#define ID_DRAW_RED              2503
#define ID_DRAW_BLUE             2504
#define ID_DRAW_PINK             2505
#define ID_DRAW_GREEN            2506
#define ID_DRAW_CYAN             2507
#define ID_DRAW_YELLOW           2508
#define ID_DRAW_BROWN            2509
#define ID_DRAW_PALEGRAY         2500
#define ID_DRAW_DARKGRAY         2511
#define ID_DRAW_DARKRED          2512
#define ID_DRAW_DARKBLUE         2513
#define ID_DRAW_DARKPINK         2514
#define ID_DRAW_DARKGREEN        2515
#define ID_DRAW_DARKCYAN         2516

#define ID_ANIMATE_INK_WHITE     2600
#define ID_ANIMATE_INK_BLACK     2601
#define ID_ANIMATE_INK_RED       2602
#define ID_ANIMATE_INK_BLUE      2603
#define ID_ANIMATE_INK_PINK      2604
#define ID_ANIMATE_INK_GREEN     2605
#define ID_ANIMATE_INK_CYAN      2606
#define ID_ANIMATE_INK_YELLOW    2607
#define ID_ANIMATE_INK_BROWN     2608
#define ID_ANIMATE_INK_PALEGRAY  2609
#define ID_ANIMATE_INK_DARKGRAY  2610
#define ID_ANIMATE_INK_DARKRED   2611
#define ID_ANIMATE_INK_DARKBLUE  2612
#define ID_ANIMATE_INK_DARKPINK  2613
#define ID_ANIMATE_INK_DARKGREEN 2614
#define ID_ANIMATE_INK_DARKCYAN  2615
#define ID_ANIMATE_INK           2616

#define ID_DRAW_INK_WHITE        2650
#define ID_DRAW_INK_BLACK        2651
#define ID_DRAW_INK_RED          2652
#define ID_DRAW_INK_BLUE         2653
#define ID_DRAW_INK_PINK         2654
#define ID_DRAW_INK_GREEN        2655
#define ID_DRAW_INK_CYAN         2656
#define ID_DRAW_INK_YELLOW       2657
#define ID_DRAW_INK_BROWN        2658
#define ID_DRAW_INK_PALEGRAY     2659
#define ID_DRAW_INK_DARKGRAY     2660
#define ID_DRAW_INK_DARKRED      2661
#define ID_DRAW_INK_DARKBLUE     2662
#define ID_DRAW_INK_DARKPINK     2663
#define ID_DRAW_INK_DARKGREEN    2664
#define ID_DRAW_INK_DARKCYAN     2665
#define ID_DRAW_INK              2666

#define ID_BLACKPEN_PTR      2700
#define hNULL                NULLHANDLE
#define MESSAGELEN           50          /* maximum length for messages */

/* define for message id     */
#define IDD_MSGBOX                 150
#define ID_MSG_NO_PEN              151
#define ID_MSG_SOM_CREATION_FAIL   152
#define ID_MSG_OPEN_FILE_FAIL      153
#define ID_MSG_BAD_BITMAP_FILE     154
#define ID_MSG_SELECT_ANOTHER_ICON 155
#define ID_MSG_INTERNAL_ERROR      156
#define ID_MSG_MEMORY_ERROR        157
#define ID_MSG_FILE_HANDLE_ERROR   158
#define ID_MSG_NO_LOWER_CASE       159

#define szAPPNAME            "IDMSAMP"
#define szANIMATENAME        "Animation Window"
#define szWRITENAME          "Write Window"
#define DOODLE_FILE          "symdb.dat"

#define SPEED_FAST 0
#define SPEED_MED  1

/* defines for 3D outlining   */
#define OUTWARD         0       /* must remain the same value as UP      */
#define INWARD          1       /* must remain the same value as DOWN    */
#define BLACK_LINES     2
#define WHITE_LINES     3
#define GRAY_LINES      4

#define NCOLOR         16
#define NAME_MAX        2
#define MAXTIME         5
#define TEXT_LEN      100

/* To map a color from color of menu item to actual color */
typedef struct _COLORMATCH
{
   SHORT   sMenuColorID;
   LONG    lColor;
}  COLORMATCH;

typedef struct _COLORCONTRAST
{
   LONG   lColor;
   SHORT  sContrastColor;
}  COLORCONTRAST;

typedef struct _ANIMATECOLORMATCH
{
   SHORT   sAnimateInkColor;
   SHORT   sColor;
}  ANIMATECOLORMATCH;

typedef struct _DRAWCOLORMATCH
{
   SHORT   sDrawInkColor;
   LONG    lColor;
}  DRAWCOLORMATCH;

typedef struct _APPLICATION
{
  CHAR   szName[NAME_MAX + 1];
  ULONG  ulStrokeTotal;            /* total number of strokes in signature   */
  ULONG  ulSignatureSize;          /* includes length bytes and stroke bytes */
}  APPLICATION;

typedef struct _FUNCTIONREC
{
   RECORDCORE       CntrRecord;
   CHAR             szText[50];
}
FUNCTIONREC, *PFUNCTIONREC;

HAB   hab;
HWND  hwndFrame, hwndMenu, hwndClient;
HDC   hdcAnimate,  hdcWrite;
HPS   hpsAnimate,  hpsWrite;

HWND  hwndWriteFrame,  hwndWriteClient;
HWND  hwndAnimateFrame, hwndAnimateClient;
HWND  hwndCntr;

LONG lBoardColor, lDrawColor, lAnimateColor, lAnimateInkColor, lDrawInkColor;
LONG lBoardCheck, lDrawCheck, lAnimateCheck, lAnimateInkCheck, lDrawInkCheck;

HPOINTER hpointerPen;

IDMObject   *objIDM;
Environment lev;
APIRET      rc;
char     display_string[100];
char     actual_string[100];
HBITMAP  hbitSmile;
HFILE    hfileDoodleFile = (HFILE) NULL;
HPOINTER hpointerPen;
IDODoodle  *pobjDoodle, *pobjAllDoodle;
ULONG      ulAnimationSpeed;
BOOL       fOutS = FALSE;
HMTX       hMtx;

COLORMATCH   cmMapColor[NCOLOR * 3] = {
                 ID_BOARD_WHITE,      CLR_WHITE,
                 ID_BOARD_BLACK,      CLR_BLACK,
                 ID_BOARD_RED,        CLR_RED,
                 ID_BOARD_BLUE,       CLR_BLUE,
                 ID_BOARD_PINK,       CLR_PINK,
                 ID_BOARD_GREEN,      CLR_GREEN,
                 ID_BOARD_CYAN,       CLR_CYAN,
                 ID_BOARD_YELLOW,     CLR_YELLOW,
                 ID_BOARD_BROWN,      CLR_BROWN,
                 ID_BOARD_PALEGRAY,   CLR_PALEGRAY,
                 ID_BOARD_DARKGRAY,   CLR_DARKGRAY,
                 ID_BOARD_DARKRED,    CLR_DARKRED,
                 ID_BOARD_DARKBLUE,   CLR_DARKBLUE,
                 ID_BOARD_DARKPINK,   CLR_DARKPINK,
                 ID_BOARD_DARKGREEN,  CLR_DARKGREEN,
                 ID_BOARD_DARKCYAN,   CLR_DARKCYAN,
                 ID_ANIMATE_WHITE,    CLR_WHITE,
                 ID_ANIMATE_BLACK,    CLR_BLACK,
                 ID_ANIMATE_RED,      CLR_RED,
                 ID_ANIMATE_BLUE,     CLR_BLUE,
                 ID_ANIMATE_PINK,     CLR_PINK,
                 ID_ANIMATE_GREEN,    CLR_GREEN,
                 ID_ANIMATE_CYAN,     CLR_CYAN,
                 ID_ANIMATE_YELLOW,   CLR_YELLOW,
                 ID_ANIMATE_BROWN,    CLR_BROWN,
                 ID_ANIMATE_PALEGRAY, CLR_PALEGRAY,
                 ID_ANIMATE_DARKGRAY, CLR_DARKGRAY,
                 ID_ANIMATE_DARKRED,  CLR_DARKRED,
                 ID_ANIMATE_DARKBLUE, CLR_DARKBLUE,
                 ID_ANIMATE_DARKPINK, CLR_DARKPINK,
                 ID_ANIMATE_DARKGREEN,CLR_DARKGREEN,
                 ID_ANIMATE_DARKCYAN, CLR_DARKCYAN,
                 ID_DRAW_WHITE,       CLR_WHITE,
                 ID_DRAW_BLACK,       CLR_BLACK,
                 ID_DRAW_RED,         CLR_RED,
                 ID_DRAW_BLUE,        CLR_BLUE,
                 ID_DRAW_PINK,        CLR_PINK,
                 ID_DRAW_GREEN,       CLR_GREEN,
                 ID_DRAW_CYAN,        CLR_CYAN,
                 ID_DRAW_YELLOW,      CLR_YELLOW,
                 ID_DRAW_BROWN,       CLR_BROWN,
                 ID_DRAW_PALEGRAY,    CLR_PALEGRAY,
                 ID_DRAW_DARKGRAY,    CLR_DARKGRAY,
                 ID_DRAW_DARKRED,     CLR_DARKRED,
                 ID_DRAW_DARKBLUE,    CLR_DARKBLUE,
                 ID_DRAW_DARKPINK,    CLR_DARKPINK,
                 ID_DRAW_DARKGREEN,   CLR_DARKGREEN,
                 ID_DRAW_DARKCYAN,    CLR_DARKCYAN    };

COLORCONTRAST  ccMatch[NCOLOR] = { CLR_WHITE,     CLR_BLACK,
                                   CLR_BLACK,     CLR_WHITE,
                                   CLR_RED,       CLR_BLACK,
                                   CLR_BLUE,      CLR_WHITE,
                                   CLR_PINK,      CLR_BLACK,
                                   CLR_GREEN,     CLR_WHITE,
                                   CLR_CYAN,      CLR_BLACK,
                                   CLR_YELLOW,    CLR_BLACK,
                                   CLR_BROWN,     CLR_WHITE,
                                   CLR_PALEGRAY,  CLR_BLACK,
                                   CLR_DARKGRAY,  CLR_WHITE,
                                   CLR_DARKRED,   CLR_WHITE,
                                   CLR_DARKBLUE,  CLR_WHITE,
                                   CLR_DARKPINK,  CLR_WHITE,
                                   CLR_DARKGREEN, CLR_WHITE,
                                   CLR_DARKCYAN,  CLR_WHITE };

ANIMATECOLORMATCH   acmColor[NCOLOR] = { ID_ANIMATE_INK_WHITE,    CLR_WHITE,
                                         ID_ANIMATE_INK_BLACK,    CLR_BLACK,
                                         ID_ANIMATE_INK_RED,      CLR_RED,
                                         ID_ANIMATE_INK_BLUE,     CLR_BLUE,
                                         ID_ANIMATE_INK_PINK,     CLR_PINK,
                                         ID_ANIMATE_INK_GREEN,    CLR_GREEN,
                                         ID_ANIMATE_INK_CYAN,     CLR_CYAN,
                                         ID_ANIMATE_INK_YELLOW,   CLR_YELLOW,
                                         ID_ANIMATE_INK_BROWN,    CLR_BROWN,
                                         ID_ANIMATE_INK_PALEGRAY, CLR_PALEGRAY,
                                         ID_ANIMATE_INK_DARKGRAY, CLR_DARKGRAY,
                                         ID_ANIMATE_INK_DARKRED,  CLR_DARKRED,
                                         ID_ANIMATE_INK_DARKBLUE, CLR_DARKBLUE,
                                         ID_ANIMATE_INK_DARKPINK, CLR_DARKPINK,
                                         ID_ANIMATE_INK_DARKGREEN,CLR_DARKGREEN,
                                         ID_ANIMATE_INK_DARKCYAN, CLR_DARKCYAN };

DRAWCOLORMATCH   dcmColor[NCOLOR] = { ID_DRAW_INK_WHITE,    CLR_WHITE,
                                      ID_DRAW_INK_BLACK,    CLR_BLACK,
                                      ID_DRAW_INK_RED,      CLR_RED,
                                      ID_DRAW_INK_BLUE,     CLR_BLUE,
                                      ID_DRAW_INK_PINK,     CLR_PINK,
                                      ID_DRAW_INK_GREEN,    CLR_GREEN,
                                      ID_DRAW_INK_CYAN,     CLR_CYAN,
                                      ID_DRAW_INK_YELLOW,   CLR_YELLOW,
                                      ID_DRAW_INK_BROWN,    CLR_BROWN,
                                      ID_DRAW_INK_PALEGRAY, CLR_PALEGRAY,
                                      ID_DRAW_INK_DARKGRAY, CLR_DARKGRAY,
                                      ID_DRAW_INK_DARKRED,  CLR_DARKRED,
                                      ID_DRAW_INK_DARKBLUE, CLR_DARKBLUE,
                                      ID_DRAW_INK_DARKPINK, CLR_DARKPINK,
                                      ID_DRAW_INK_DARKGREEN,CLR_DARKGREEN,
                                      ID_DRAW_INK_DARKCYAN, CLR_DARKCYAN };



/*
 *  Function prototypes and variables for main window subclassing
 */
MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY AnimateWndProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY WriteWndProc( HWND, ULONG, MPARAM, MPARAM );
VOID             out_string(HWND, PSZ, ULONG);
VOID             CheckIt(SHORT);
VOID             UnCheckIt(SHORT);
VOID             FileOpen(HWND, MPARAM);
PSZ              ExtractPath( PSZ, PSZ, PSZ );
VOID             Update(HWND);
VOID             Animate(PSZ, PSZ);
BOOL             Paint3dLines( HPS, PRECTL, ULONG);
VOID             ClearWindowArea(HWND, HPS, BOOL, LONG);
MRESULT          menu_cmd(HWND, ULONG, MPARAM, MPARAM);
SHORT            contrast(LONG);
VOID             draw_ink_color(LONG);
PSZ              AnimateChar(HWND, HPS, CHAR, PRECTL, LONG, ULONG, HFILE);
VOID             AnimateDoodle(IDODoodle *, HPS, ULONG, LONG);
int              GetDoodle(HWND, PCHAR, IDODoodle *, HFILE);
VOID             ScaleAndPlace(IDODoodle *, HPS, PRECTL, LONG);
PFUNCTIONREC     LoadFunctRecord(HWND, PSZ, PSZ);
int              strs_the_same(PSZ, PSZ);
VOID             new_box(PRECTL, CHAR);
LONG             map_id_to_color(SHORT);
USHORT           ShowMessageBox(HWND, USHORT);
