/******************************************************************************
*                                                                             *
*   Name:  IDOSAMP.H                                                          *
*                                                                             *
*   Copyright : COPYRIGHT IBM CORPORATION, 1995                               *
*               LICENSED MATERIAL - PROGRAM PROPERTY OF IBM                   *
*                                                                             *
*   Description: This program lets user to draw any stroke in a window,       *
*                select one stroke and change attributes of the stroke, and   *
*                redisplay the strokes with changed attributes.               *
*                                                                             *
*                No recognition of stroke is needed in this program whether   *
*                the stroke is gesture or alphabets. So no IDM object is      *
*                created in this program.                                     *
*                                                                             *
*   Execution Instruction: IDOSAMP                                            *
*                                                                             *
*   Software Requirement: IBM OS/2 V2.1, Pen for OS/2 V1.1                    *
*                                                                             *
*  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is                *
*      sample code created by IBM Corporation. This sample code is not        *
*      part of any standard or IBM product and is provided to you solely      *
*      for  the purpose of assisting you in the development of your           *
*      applications.  The code is provided "AS IS", without                   *
*      warranty of any kind.  IBM shall not be liable for any damages         *
*      arising out of your use of the sample code, even if they have been     *
*      advised of the possibility of such damages.                            *
*                                                                             *
******************************************************************************/
#define ID_IDOSAMP        2000
#define IDO_DRAWALL         10          /* Menu items */
#define IDO_DRAW            11
#define IDO_REDRAW_OPT      12
#define IDO_REDRAW_DEF      13
#define IDO_REDRAW_DOO      14
#define IDO_REDRAW_INK      15
#define IDO_EXIT            16
#define IDO_CHANGE          17
#define IDO_MODIFY          18
#define IDO_SELECT          19
#define IDO_MDOODLE         20
#define IDO_MINKER          21
#define IDO_MRSTROKE        22
#define IDO_MCDOODLE        23

#define IDD_ATTRIBUTE       20
#define IDD_ATTR            21
#define IDD_OK              29
#define IDD_CANCEL          30

#define ID_CROSS           132

/* Dlg Box ID's for Color Selection */
#define IDC_WHITE           31
#define IDC_BLACK           32
#define IDC_BLUE            33
#define IDC_RED             34
#define IDC_PINK            35
#define IDC_GREEN           36
#define IDC_CYAN            37
#define IDC_YELLOW          38
#define IDC_DARKGRAY        39
#define IDC_DARKBLUE        40
#define IDC_DARKRED         41
#define IDC_DARKPINK        42
#define IDC_DARKGREEN       43
#define IDC_DARKCYAN        44
#define IDC_BROWN           45
#define IDC_PALEGRAY        46

/* Dlg Box ID's for line width */
#define IDLW_1              50
#define IDLW_2              51

/* Dlg Box ID for line type */
#define IDLT_DEFAULT        60
#define IDLT_DOT            61
#define IDLT_SHORTDASH      62
#define IDLT_DASHDOT        63
#define IDLT_DOUBLEDOT      64
#define IDLT_LONGDASH       65
#define IDLT_DASHDOUBLEDOT  66
#define IDLT_SOLID          67
#define IDLT_ALTERNATE      68
#define IDLT_INVISIBLE      69

/* Dlg Box ID for line set mix */
#define IDSM_DEFAULT        70
#define IDSM_OR             71
#define IDSM_OVERPAINT      72
#define IDSM_LEAVEALONE     73
#define IDSM_XOR            74
#define IDSM_AND            75
#define IDSM_SUBTRACT       76
#define IDSM_MASKSRCNOT     77
#define IDSM_ZERO           78
#define IDSM_NOTMERGESRC    79
#define IDSM_NOTXORSRC      80
#define IDSM_INVERT         81
#define IDSM_MERGESRCNOT    82
#define IDSM_NOTCOPYSRC     83
#define IDSM_MERGENOTSRC    84
#define IDSM_NOTMASKSRC     85
#define IDSM_ONE            86

/* Dlg Box ID for Offset */
#define X_OFFSET            90
#define Y_OFFSET            91
#define OFFSETTEXT          92

#define NLINES              19
#define NCOLOR              16
#define NWIDTH               4
#define NTYPE               10
#define NSETMIX             17

#define STR_1              101
#define STR_2              102
#define STR_3              103
#define STR_4              104
#define STR_5              105
#define STR_6              106
#define STR_7              107
#define STR_8              108
#define STR_9              109
#define GAP_X                3
#define GAP_Y                3

/* Redrawing Options */
#define REDRAW_DEF           1
#define REDRAW_DOO           2
#define REDRAW_INK           3

/*******************************************************************
*  The LINECOLOR, LINEWIDTH, LINETYPE, and LINESETMIX struct types *
*  are for the line attributes setting.                            *
*******************************************************************/
typedef struct {
   INT   nLColor;
   INT   nLineColor;
} LINECOLOR;
LINECOLOR LColor[NCOLOR] = {IDC_WHITE,      CLR_WHITE,
                            IDC_BLACK,      CLR_BLACK,
                            IDC_BLUE,       CLR_BLUE,
                            IDC_RED,        CLR_RED,
                            IDC_PINK,       CLR_PINK,
                            IDC_GREEN,      CLR_GREEN,
                            IDC_CYAN,       CLR_CYAN,
                            IDC_YELLOW,     CLR_YELLOW,
                            IDC_DARKGRAY,   CLR_DARKGRAY,
                            IDC_DARKBLUE,   CLR_DARKBLUE,
                            IDC_DARKRED,    CLR_DARKRED,
                            IDC_DARKPINK,   CLR_DARKPINK,
                            IDC_DARKGREEN,  CLR_DARKGREEN,
                            IDC_DARKCYAN,   CLR_DARKCYAN,
                            IDC_BROWN,      CLR_BROWN,
                            IDC_PALEGRAY,   CLR_PALEGRAY  };

typedef struct {
   INT   nLWidth;
   INT   nLineWidth;
} LINEWIDTH;
LINEWIDTH LWidth[NWIDTH] = {IDLW_1,  1,
                            IDLW_2,  2 };

typedef struct {
   INT   nLType;
   INT   nLineType;
} LINETYPE;
LINETYPE  LType[NTYPE] = {IDLT_DEFAULT,        LINETYPE_DEFAULT,
                          IDLT_DOT,            LINETYPE_DOT,
                          IDLT_SHORTDASH,      LINETYPE_SHORTDASH,
                          IDLT_DASHDOT,        LINETYPE_DASHDOT,
                          IDLT_DOUBLEDOT,      LINETYPE_DOUBLEDOT,
                          IDLT_LONGDASH,       LINETYPE_LONGDASH,
                          IDLT_DASHDOUBLEDOT,  LINETYPE_DASHDOUBLEDOT,
                          IDLT_SOLID,          LINETYPE_SOLID,
                          IDLT_ALTERNATE,      LINETYPE_ALTERNATE,
                          IDLT_INVISIBLE,      LINETYPE_INVISIBLE      };

typedef struct {
   INT   nLSMix;
   INT   nLineSMix;
} LINESETMIX;
LINESETMIX  LSetMix[NSETMIX] = {IDSM_DEFAULT,      FM_DEFAULT,
                                IDSM_OR,           FM_OR,
                                IDSM_OVERPAINT,    FM_OVERPAINT,
                                IDSM_LEAVEALONE,   FM_LEAVEALONE,
                                IDSM_XOR,          FM_XOR,
                                IDSM_AND,          FM_AND,
                                IDSM_SUBTRACT,     FM_SUBTRACT,
                                IDSM_MASKSRCNOT,   FM_MASKSRCNOT,
                                IDSM_ZERO,         FM_ZERO,
                                IDSM_NOTMERGESRC,  FM_NOTMERGESRC,
                                IDSM_NOTXORSRC,    FM_NOTXORSRC,
                                IDSM_INVERT,       FM_INVERT,
                                IDSM_MERGESRCNOT,  FM_MERGESRCNOT,
                                IDSM_NOTCOPYSRC,   FM_NOTCOPYSRC,
                                IDSM_MERGENOTSRC,  FM_MERGENOTSRC,
                                IDSM_NOTMASKSRC,   FM_NOTMASKSRC,
                                IDSM_ONE,          FM_ONE            };

typedef struct _ATTRCHG
{
   BOOL fAttrChg;
   INT  nLWidth;
   INT  nColor;
   INT  nLType;
   INT  nSMix;
   LONG nX, nY;    /* for offset change */
}  ATTRCHG;

INT     nColor, nWidth, nType, nSMix;
HAB     hab;
HDC     hdc;
HWND    hwndFrame;
BOOL    fSelect = FALSE;     /* Flag whether user selects a stroke to change
                                its attribute.                              */
BOOL    fModify = FALSE;     /* MODIFY menu item is disabled (FALSE)        */
Environment lev;

CHAR    achInit[][80] = { "          IDO  Sample  Program",
   " ",
   "To use this program, you may start drawing strokes in this window",
   "at any time. The menu items may be used to modify stroke, doodle,",
   "and inker information, remove a stroke, clear a doodle, and",
   "specify how to redraw the strokes.",
   " ",
   "Menu Item Descriptions",
   " ",
   "Action",
   "   Modify:        You can modify attributes for a stroke, doodle, or inker.",
   "   Remove Stroke: You can select a stroke and remove it from the doodle.",
   "   Clear Doodle:  You can remove all strokes from a doodle.",
   "   Exit:          Exit this sample program.",
   "Redraw Option",
   "   Default: Redraw the strokes, using the default drawing option",
   "            (use the InkAttr of the stroke if it exists).",
   "   Doodle:  Redraw the strokes, using the InkAttr of the Doodle.",
   "   Inker:   Redraw the strokes, using the ink attribute of the Inker."
   };

MRESULT EXPENTRY ClientWinProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY AttrDlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
VOID RemoveStrokes(IDODoodle *);
VOID  PutString(HWND, ULONG, BOOL);
