
/******************************************************************************
*                                                                             *
*   Name:  IDRSAMP.H                                                          *
*                                                                             *
*   Copyright : COPYRIGHT IBM CORPORATION, 1995                               *
*               LICENSED MATERIAL - PROGRAM PROPERTY OF IBM                   *
*                                                                             *
*   Description:                                                              *
*                                                                             *
*   Software Requirement: IBM WARP and Pen for OS/2 V1.1                      *
*                                                                             *
*  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is                *
*      sample code created by IBM Corporation. This sample code is not        *
*      part of any standard or IBM product and is provided to you solely      *
*      for  the purpose of assisting you in the development of your           *
*      applications.  The code is provided "AS IS", without                   *
*      warranty of any kind.  IBM shall not be liable for any damages         *
*      arising out of your use of the sample code, even if they have been     *
*      advised of the possibility of such damages.                            *
*                                                                             *
******************************************************************************/

/* Defines for the application's main window */
#define ID_IDRSAMP                   32

/* Defines for the Metrics dialog box */
#define ID_METRICS_DLG              210
#define ID_FORM_BOXED               211
#define ID_FORM_LINED               212
#define ID_FORM_UNLINED             213
#define ID_DISABLE_SPACE            214
#define ID_DISABLE_ENTER            215
#define ID_ORIGIN_X                 216
#define ID_ORIGIN_Y                 217
#define ID_OFFSET_X                 218
#define ID_OFFSET_Y                 219
#define ID_BOX_X                    220
#define ID_BOX_Y                    221
#define ID_GRAY_X                   222
#define ID_GRAY_Y                   223
#define ID_BASELINE                 224
#define ID_ROW                      225
#define ID_COL                      226
#define ID_METRICS_DONE             227
#define ID_METRICS_CANCEL           228

/* Defines for the Symbol Sets Dialog Box */
#define ID_SYMSETS_DLG              230
#define ID_SYMSETS_ALPHALO          231
#define ID_SYMSETS_ALPHAHI          232
#define ID_SYMSETS_DIGITS           233
#define ID_SYMSETS_PUNC             234
#define ID_SYMSETS_MATH             235
#define ID_SYMSETS_MONEY            236
#define ID_SYMSETS_SPECIAL          237
#define ID_SYMSETS_FULL             238
#define ID_SYMSETS_DONE             239
#define ID_SYMSETS_CANCEL           240

/* Defines the Language Model (Dictionary) Dialog Box */
#define ID_LM_DLG                   250
#define ID_LMCASE_FORCE             251
#define ID_LM_NONE                  252
#define ID_LM_ADVICE                253
#define ID_LM_FORCE                 254
#define ID_LM_REJECT                255
#define ID_LM_UNKNOWN               256
#define ID_TXT_WRDCASE              257
#define ID_TXT_SENTCASE             258
#define ID_TXT_ALPHANUM             259
#define ID_TXT_BRACKET              260
#define ID_LM_DONE                  261
#define ID_LM_CANCEL                262

/* Define for IDF_ERR message handling dialog box */
#define ID_ERROR_DLG                290
#define ID_ERROR_RC                 291
#define ID_ERROR_CLASS              292
#define ID_ERROR_METHOD             293
#define ID_ERROR_DONE               294

/* Number of Symbols */
#define NUM_SYMSETS                   7
#define NUM_ALPH                     26
#define NUM_DIGITS                   10
#define NUM_PUNC                     13
#define NUM_MATH                     15
#define NUM_MONEY                     2
#define NUM_SPECIAL                  12

/* Number of Language Model Coercion */
#define NUM_COERCION                  4

/* Number of Language Model Policy   */
#define NUM_POLICY                    4

/* Defines for the text result dialog */
#define ID_RESULT_DLG               300
#define ID_RES_TOP                  301
#define ID_RES_BOX                  302
#define ID_RES_HANDLES              303
#define ID_RES_COUNT                304
#define ID_RES_INFO                 305
#define ID_RES_BOX_NEXT             306
#define ID_RES_COUNT_NEXT           307
#define ID_RES_INFO_NEXT            308
#define ID_TXT_SHORTCUTS            310
#define ID_TXT_INDEPTH              311
#define ID_TXT_NXBOX                312
#define ID_TXT_NXCOUNT              313
#define ID_TXT_NXINFO               314
#define ID_RESULT_DONE              320

/* Defines for the gesture result dialog */
/*
#define ID_GESTURE_DLG              500
#define ID_SHAPE                    501
#define ID_VIRTID                   502
#define ID_CHARCODE                 503
#define ID_RECODATA                 504
#define ID_TXT_SHAPE                510
#define ID_TXT_VIRTID               511
#define ID_TXT_CHARCODE             512
#define ID_TXT_RECODATA             513
#define ID_GESTURE_DONE             520
#define ID_FORM_STROKE              601
#define ID_FORM_SYM                 602
*/

/* error messages */
#define STR_1                       175
#define STR_2                       176
#define STR_3                       177
#define STR_4                       178
#define STR_5                       179
#define STR_6                       180
#define STR_7                       181
#define STR_8                       182
#define STR_9                       183

#define STR_11                      189

/* Defines for the application's main menu */
#define ID_RECOTYPE                 110
#define ID_TEXT                     111
#define ID_GESTURE                  112
#define ID_SETS_MENU                120
#define ID_METRICS                  121
#define ID_SYMSETS                  122
#define ID_LM                       123
#define ID_RECOTYPE_MENU            130
#define ID_RECO_MENU                140
#define ID_RECO                     141
#define ID_CLEAR                    142
#define ID_QUIT                     150


/* Defines for the text result dialog */
#define ID_RESULT_DLG         300
#define NUM_RES               310
#define TOP_RES               311
#define NEXT_RES              312
#define NEXT_RES_NO           313
#define BOX_R1                314
#define BOX_NO                315
#define BOX_R2                316
#define BOX_RES               317
#define ID_NEXTB              318
#define ID_DONE               319
#define ID_NEXT               320

/* Defines for the gesture result dialog
#define ID_GESTURE_DLG              500
#define ID_SHAPE                    501
#define ID_VIRTID                   502
#define ID_CHARCODE                 503
#define ID_RECODATA                 504
#define ID_TXT_SHAPE                510
#define ID_TXT_VIRTID               511
#define ID_TXT_CHARCODE             512
#define ID_TXT_RECODATA             513
*/

/* Defines for the Gesture result dislog box */
#define ID_GESTURE_DLG              330
#define V_ID                        331
#define C_ID                        332
#define GES_NAME                    333

#define NUM_INITIAL_LINES            19
#define MAX_CLUSTER                  64
#define MAX_RESULTS                  10

#define TEXT_MODE                     1
#define GESTURE_MODE                  2

#define HANDLE_GESTURE                WM_USER + 1

typedef struct _LANGMODEL
{
   ULONG  ulCoercion;
   ULONG  ulPolicy;
}  LANGMODEL;
typedef LANGMODEL  *PLANGMODEL;

typedef struct _CLUSTERDATA
{
   HCLUSTER    hCls;
   ULONG       ulNumRes;
} CLUSTERDATA;

/* Function prototypes */
int main ( VOID );
MRESULT EXPENTRY ClientWinProc ( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY MetricsDlgProc ( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY SymsetsDlgProc ( HWND, ULONG, MPARAM, MPARAM );

MRESULT EXPENTRY ResultDlgProc ( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY GestureDlgProc ( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY SymsetDlgProc ( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY DictionaryDlgProc ( HWND, ULONG, MPARAM, MPARAM );
MRESULT EXPENTRY IDRErrorDlgProc ( HWND, ULONG, MPARAM, MPARAM );
VOID             GiveBoxedForm(HWND, HPS, SIZEL, IDR_RECOMETRICS);
VOID             GiveLinedForm(HWND, HPS, SIZEL, IDR_RECOMETRICS);
VOID             PutString(HWND, ULONG, BOOL);
VOID             SetSymbols(HWND, ULONG, ULONG *, PPIDR_SYM);
ULONG            GetSymStringProc(PIDR_SYM, ULONG, PCHAR);
BOOL             Text_GetMetrics(IDR_RECOMETRICS *);
BOOL             Text_SetMetrics(HWND, IDRText *, ULONG, ULONG, ULONG, IDR_RECOMETRICS *);

/* global variables */
HAB         hab;
ULONG       maskActions;
Environment lev;
PRECODATA   prdb;
HWND        hwndFrame, hwndClient;
RECODATA    RecoData;
PHCLUSTER   phandles;
IDR_SYM     idrSym;
IDR_SYMSET  idrSymset;
IDR_RECOMETRICS idrGMetrics;
ULONG       ulSymSets[NUM_SYMSETS][2] = { IDR_SYMSET_ALPHALO,     NUM_ALPH,
                                          IDR_SYMSET_ALPHAHI,     NUM_ALPH,
                                          IDR_SYMSET_DIGIT,       NUM_DIGITS,
                                          IDR_SYMSET_PUNCTUATION, NUM_PUNC,
                                          IDR_SYMSET_MATH,        NUM_MATH,
                                          IDR_SYMSET_MONETARY,    NUM_MONEY,
                                          IDR_SYMSET_SPECIAL,     NUM_SPECIAL };
LANGMODEL   lModel;
ULONG       ulLMCoercion[NUM_COERCION] = { IDR_LM_ADVISE,
                                           IDR_LM_FORCE,
                                           IDR_LM_REJECT,
                                           IDR_LM_NONE };

ULONG       ulLMPolicy[NUM_POLICY] = { IDR_TXTLM_WRDCASE,
                                       IDR_TXTLM_SENTCASE,
                                       IDR_TXTLM_ALPHANUM,
                                       IDR_TXTLM_BRACKETS };

IDF_PROB  *Prob;
ULONG     rc;
BOOL      fFirstMsg = TRUE;

/* to get and set metrics, get the device info */
WRTSYSTEMINFO     WrtSi;
WRTLOCATORDEVINFO WrtLi;

/* Limit of 64 maximum clusters */
CLUSTERDATA  clData[MAX_CLUSTER];

CHAR achInit[][80] = { "          IDR  Sample  Program",
        " ",
        "To use this program, you may start drawing strokes in this window at",
        "any time. The menu items may be used to setup the recognition type",
        "(Text, Gesture, or both), specify recognition settings for metrics,",
        "symbol subsets, or language modeling, and recognize or clear strokes.",
        " ",
        "Menu Item Description",
        "  Reco Type",
        "     Text:              Enable text recognition",
        "     Gesture:           Enable gesture recognition",
        "     Exit:              Exit this sample program",
        "  Settings",
        "     Metrics:          Change reco metrics ",
        "     Symbol Subsets: Change symbol subsets",
        "     Language Model: Change dictionary policy and coercion",
        "  Actions",
        "     Reco:             Perform recognition",
        "     Clear:             Clear the strokes"
        };
