/*****************************************************************************/
/*                                                                           */
/*  File Name   : SLESAMP.H                                                  */
/*                                                                           */
/*  Copyright (C) 1995 IBM Corporation                                       */
/*                                                                           */
/*      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is          */
/*      sample code created by IBM Corporation. This sample code is not      */
/*      part of any standard or IBM product and is provided to you solely    */
/*      for  the purpose of assisting you in the development of your         */
/*      applications.  The code is provided "AS IS", without                 */
/*      warranty of any kind.  IBM shall not be liable for any damages       */
/*      arising out of your use of the sample code, even if they have been   */
/*      advised of the possibility of such damages.                          */
/*                                                                           */
/*****************************************************************************/

#ifndef SLESAMP_INCLUDED

#define  SLESAMP_INCLUDED

#define MAXROWS               6
#define MAXCOLS               8
#define ROWFROMID( x )        ((x) / 10)
#define COLFROMID( x )        ((x) % 10)
#define IDFROMROWCOL( x, y )  (((x) * 10) + (y))
#define FIELDID( x )          (((x) > 0) && ((x) <= RESERVED))
#define RESERVED              ((MAXROWS * 10) + 9)

#define WM_CLR_SIG            WM_USER+1

#define ID_EXPACCNT           RESERVED+1
#define ID_OK                 RESERVED+2
#define ID_CANCEL             RESERVED+3
#define ID_PRINT              RESERVED+4
#define ID_EMPNAME            RESERVED+5
#define ID_EMPSRL             RESERVED+6
#define ID_EMPSIG             RESERVED+7
#define ID_EMPTEL             RESERVED+8
#define ID_EMPNODE            RESERVED+9
#define ID_EMPDEPT            RESERVED+10
#define ID_EMPLOC             RESERVED+11
#define ID_EMPZIP             RESERVED+12
#define ID_EMPBLDG            RESERVED+13
#define ID_EMPDATE            RESERVED+14
#define ID_APRVLNAME          RESERVED+15
#define ID_APRVLSIG           RESERVED+16
#define ID_APRVLDATE          RESERVED+17
#define ID_FIN_TOTAL          RESERVED+18

#define FIN_TOT_WIDTH         7

#define LCID_PRNFONT          1L

#define IDS_EMPHDR1           1
#define IDS_EMPHDR2           2
#define IDS_DATAHDR           3
#define IDS_APRVLHDR          4



MRESULT EXPENTRY ClientWndProc (HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY EmpSigWndProc (HWND, ULONG, MPARAM, MPARAM);
MRESULT EXPENTRY AprvlSigWndProc (HWND, ULONG, MPARAM, MPARAM);
VOID AddFields (HWND hWnd);
VOID PositionFields (HWND hWnd);
VOID UpdateTotals (HWND hwndClient, ULONG id);
VOID Printout (HWND hWnd);
HDC OpenDefaultPrinterDC (HAB hab);
VOID PrintSignature (HAB hab, HBITMAP hbm, HDC hdcPrinter, HPS hpsPrinter,
                     POINTL pt, HWND hWnd);

#endif /* SLESAMP_INCLUDED */
