#===================================================================
#
# SLESAMP Make File
#
#===================================================================
#
#===================================================================
#
.SUFFIXES:
.SUFFIXES: .rc .res .obj .h .c .exe .def .map

#===================================================================
#
#  Symbol definitions
#
#===================================================================

#===================================================================
#
# Default compilation macros for sample programs
#
#===================================================================
#
# Compile switchs  that are enabled
#
# /c      compile don't link
# /Fa+    Write ASM  file to DASD ( + = YES, - = NO
# /Fd+    Write temp file to DASD ( /Fd- = Write temp files to virtual memory )
# /Fl+    Write basic listing file  ( + = YES, - = NO )
# /Gd     use runtime library that: ( + = Dynamic Link, - = Static Link )
# /Ge     use runtime library that: ( + = EXE Built,    - = DLL Built )
# /Gm     use the multi-threaded libraries ( + = YES, - = NO )
# /Kb     Control basic diagnostic message (/Kb+ = ON, /Kb- = OFF )
# /Kp     Unused Parameter Messages        (/Kp+ = ON, /Kp- = OFF )
# /Fp2    Pack on two byte boundaries
# /Lf+    Write full  listing file  ( + = YES, - = NO )
# /Ms     use the system calling convention and not optilink as the default
# /O      Optimization: ( + = ON, - = OFF )
# /Rx     Subsystem Development (where x = e | n, e=runtime environ, n=none)
# /Se     allow cset  extensions
# /Ss     allow  "//" for comment lines
# /SpX    Pack on "X" boundary, where "X" is 1, 2, 4
# /Ti     Debug Information
#

#-------------------------------------------------------------------
#   Variables used in compile steps
#-------------------------------------------------------------------

HDRS = slesamp.h globals.h
LIBS = os2386.lib penpm.lib

CC = icc
CFLAGS = -c -Ss+ -Sp2

RC = rc
RCFLAGS = -r -i $(PENTKTH) -i $(TKTH)

LINK = link386
LFLAGS = /NOI /LINENUMBER /DEBUG /PM:PM /MAP /align:4 /base:0x10000

#-------------------------------------------------------------------
#   Compilation rules and dependencies
#-------------------------------------------------------------------

.obj.exe:
    $(LINK) $(LFLAGS) $*.obj, $*.exe, $*.map, $(LIBS), $*.def;
    rc $*.res

.c.obj:
    $(CC) $(CFLAGS) $<

.rc.res:
    $(RC) $(RCFLAGS) $*.rc

slesamp.exe: slesamp.obj slesamp.def slesamp.res
slesamp.obj: slesamp.c $(HDRS)

clean:
    -del *.obj
    -del *.sym
    -del *.map
    -del *.res
